--  fichier ts_new_bounded.adb
--  pour tester le TP 12B
--  attention les Bounded_String ne sont pas issus
--  du paquetage officiel mais du clone fabriqu
--  comparez le fichier bounded.out gnr ici avec le
--  fichier bounded.ora gnr par l'excutable Crea_Ora 

with P_Bounded_80;          use P_Bounded_80;
with P_Bounded_Io_80;       use P_Bounded_Io_80;
with P_New_Bounded_80;      use P_New_Bounded_80; 
with Ada.Text_Io;           use Ada.Text_Io;

with Ada.Exceptions;        use Ada.Exceptions;

procedure Ts_New_Bounded is 

   Ind         : Natural;  
   Ch_Bounded1 : Bounded_String;  
   Ch_Bounded2 : Bounded_String;  
   Fich_In,  
   Fich_Out    : File_Type;  

begin

   Open (Fich_In, In_File, "bounded.in");
   Create (Fich_Out, Name => "bounded.out");
   Set_Output (Fich_Out);
   -- permet de ne pas prfixer les Put avec Fich_Out !
   loop
      exit when End_Of_File(Fich_In);

      -- lecture d'une premire chaine
      Ch_Bounded1 := Get_Line(Fich_In);

      Put ("Affichage du premier BOUNDED_STRING : ");
      Put_Line (Ch_Bounded1);

      Put ("Affichage de sa longueur : ");
      Put_Line (Integer'Image(Length(Ch_Bounded1)));

      -- lecture d'une deuxime chaine
      Ch_Bounded2 := Get_Line(Fich_In);

      Put ("Affichage du deuxime BOUNDED_STRING : ");
      Put_Line (Ch_Bounded2);

      Put ("Affichage de sa longueur : ");
      Put_Line (Integer'Image(Length(Ch_Bounded2)));

      Put_Line ("Affichage de la concatnation des deux chaines");
      Put(Ch_Bounded1 & ' ' & Ch_Bounded2);
      New_Line;

      if P_New_Bounded_80."=" (Ch_Bounded1,Ch_Bounded2)
            then
         Put_Line("Les deux chanes sont gales ");
      else
         Put_Line("Les deux chanes ne sont pas gales ");
      end if;
      if Ch_Bounded1 <= Ch_Bounded2
            then
         Put_Line(
            "La chaine1 est plus petite ou gale  la chaine2");
      else
         Put_Line(
            "La chaine1 est plus grande que la chaine2 ");
      end if;

      Ind :=Index(Ch_Bounded1,To_String(Ch_Bounded2));
      if Ind >0
            then
         Put(
            "La chane2 est prsente dans la chaine1 en position : ");
         Put(Integer'Image(Ind));
         New_Line;
      else
         Put_Line ("La chane2 n'est pas dans la premire ");
      end if;
      begin
         Insert (Ch_Bounded1,3,To_String(Ch_Bounded2));
         Put(
            "La chane2 est insre dans la 1 en position 3 : ");
         Put_Line(Ch_Bounded1);
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information (Marqueur));
      end;
      begin
         Delete (Ch_Bounded1,3, 3 + Length(Ch_Bounded2) - 1);
         Put("La chane2 est retire de la premire : ");
         Put_Line(Ch_Bounded1);
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information (Marqueur));
      end;
      begin
         Overwrite (Ch_Bounded1,5,To_String(Ch_Bounded2));
         Put("La chane2 est crite sur la 1 en position 5 : ");
         Put_Line(Ch_Bounded1);
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information (Marqueur));
      end;
      begin
         Put("fabrication d'une chane de 12 caractres avec 'A' : ");
         Ch_Bounded1 := 12 * 'A' ;
         Put("Affichage de la chane : ");
         Put_Line(Ch_Bounded1);
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information (Marqueur));
      end;

      New_Line (2);
   end loop;
   Close (Fich_In);
   Close (Fich_Out);

end Ts_New_Bounded;
 
