-- Fichier ts_poly2.adb
-- TP 13B
-- pour tester le paquetage P_Poly_Vl_G.V2
-- le test n'utilise plus Set mais Get
-- D.Feneuille & T.Avignon

with P_Rationnels_G.Io;          -- use stupide
with P_Poly_V1_G.V2;             -- use stupide
with Ada.Text_Io;                use Ada.Text_Io;
with Ada.Exceptions;             use Ada.Exceptions;

procedure Ts_Poly2 is 

   type T_Entier is range - 40000 .. 400000; -- pas symtrique!

   package P_Rationnels is  new   P_Rationnels_G(T_Entier);
   package P_Rationnels_Io is new P_Rationnels.Io;

   use P_Rationnels;
   use P_Rationnels_Io;

   package P_Poly_Vrai1 is new
      P_Poly_V1_G(10,P_Rationnels,P_Rationnels_Io);
   -- pas de use ici pour les ambiguts
   package P_Poly_Vrai is new P_Poly_Vrai1.V2;
   use P_Poly_Vrai;

   package E_S_Float is new Float_Io(Float);
   use E_S_Float;

   Poly1,  
   Poly2,  
   Poly3    : P_Poly_Vrai1.T_Polynome;    -- trois polynmes                    
   Fich : File_Type;  

begin
   Put_Line (Standard_Output,
      "entrez le polynome sur une ligne sparez les coefficients");
   Get (Standard_Input,Poly3); -- ici lecture clavier
   New_Line(Standard_Output);
   Put("test lecture clavier POLY3");
   New_Line;
   Put(Poly3);
   New_Line;
   Open (Fich,Name => "fic_poly.in", Mode => In_File);
   loop
      exit when End_Of_File(Fich);
      Get (Fich,Poly1);
      New_Line;
      Put ("POLYl : ");
      Put(Poly1);
      New_Line;
      Put ("valeur de poly1 pour X = 0.5 : ");
      begin
         Put (Valeur(Poly1,0.5),Exp => 0);
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information(Marqueur));
      end;
      New_Line;
      Get (Fich,Poly2);
      New_Line;
      Put ("POLY2 : ");
      Put(Poly2);
      New_Line;
      Put_Line ("Pl + P2 = ");
      New_Line;
      begin
         Put(Poly1 + Poly2);
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information(Marqueur));
      end;
      New_Line;
      Put_Line ("Pl - P2 = ");
      New_Line;
      begin
         Put(Poly1 - Poly2);
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information(Marqueur));
      end;
      New_Line;
      Put_Line ("Inverse de Pl :");
      New_Line;
      begin
         Poly3 := - Poly1;
         Put(Poly3);
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information(Marqueur));
      end;
      New_Line;
      Put_Line ("Pl * P2 = ");
      New_Line;
      begin
         Put(Poly1 * Poly2);
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information(Marqueur));
      end;
      New_Line;
      Put_Line ("Drive de Pl : ");
      New_Line;
      begin
         Put(Derivee(Poly1));
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information(Marqueur));
      end;
      New_Line;
      Put_Line ("POLY1 + (POLY1 * POLY2)");
      New_Line;
      begin
         Put(Poly1 + (Poly1 * Poly2));
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information(Marqueur));
      end;
      New_Line;
      Put_Line ("POLY1 + POLY1 * POLY2");
      New_Line;
      begin
         Put(Poly1 + Poly1 * Poly2);
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information(Marqueur));
      end;
      New_Line;
      Put_Line ("POLY1 * (POLY1 + POLY2)");
      New_Line;
      begin
         Put(Poly1 * (Poly1 + Poly2));
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information(Marqueur));
      end;
      New_Line;
      Put_Line ("POLY1 * POLY1 + POLY2");
      New_Line;
      begin
         Put(Poly1 * Poly1 + Poly2);
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information(Marqueur));
      end;
      New_Line;
      Put_Line ("(POLY1 * POLY1) + (POLY1 * POLY2)");
      New_Line;
      begin
         Put((Poly1 * Poly1) + (Poly1 * Poly2));
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information(Marqueur));
      end;
      New_Line;
      Put_Line ("POLY1 * POLY1 + POLY1 * POLY2");
      New_Line;
      begin
         Put(Poly1 * Poly1 + Poly1 * Poly2);
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information(Marqueur));
      end;
      New_Line;
      Put_Line("reste de Poly1/Poly2");
      New_Line;
      begin
         Poly3:= Poly1 rem Poly2;
         P_Poly_Vrai1.Ecrire(Poly3);
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information(Marqueur));
      end;
      Put_Line("Quotient Poly1/Poly2");
      New_Line;
      begin
         Poly3:= Poly1 / Poly2;
         P_Poly_Vrai1.Ecrire(Poly3);
      exception
         when Marqueur : others =>
            Put_Line (Exception_Information(Marqueur));
      end;
      New_Line(2);
   end loop;
   Close(Fich);
end Ts_Poly2;
