-- fichier p_proba1.adb
--  raliser compltement  partir du squelette
-- TP 14 (dbut)

package body P_Proba1 is

   package Reel_Io is new Ada.Text_Io.Float_Io (T_Proba);

   function "+" (
         Un,                   
         Deux : in     T_Proba ) 
     return T_Proba is 
   begin
      return T_Proba (Float (Un) + Float (Deux)
         - Float (Un) * Float (Deux));
   end "+";

   function "*" (
         Un,                   
         Deux : in     T_Proba ) 
     return T_Proba is 
   begin
      return T_Proba (Float (Un) * Float (Deux) );
   end "*";

   function "-" (
         Un : in     T_Proba ) 
     return T_Proba is 
   begin
      return 1.0 - Un ; -- conversion en FLOAT inutile ici !
   end "-";

   procedure Get (
         Un :    out T_Proba ) is -- lecture valide
   begin
      loop
         begin
            Reel_Io.Get (Un);
            Ada.Text_Io.Skip_Line;
            exit;
         exception
            when others =>
               Ada.Text_Io.Skip_Line;
               Ada.Text_Io.Put_Line (" un numrique svp entre 0.0 et 1.0");
         end;
      end loop;
   end Get;

   procedure Put (
         Un : in     T_Proba ) is 
   begin
      Reel_Io.Put(Un, 10, 5, 0); -- voir P_E_Sortie (mieux!)
   end Put;

   procedure Get (
         Fich : in     File_Type; 
         Un   :    out T_Proba    ) is 
   begin
      Reel_Io.Get (Fich, Un);
   end Get;


   procedure Put (
         Fich : in     File_Type; 
         Un   : in     T_Proba    ) is 
   begin
      Reel_Io.Put (Fich, Un, 10, 5, 0);
   end Put;

end P_Proba1;
